#!/usr/bin/python3
import paho.mqtt.client as mqtt
import time
import configparser
import json
import os
import argparse
import re
import getopt
import subprocess
from datetime import datetime, timezone
LOGLEVELDEBUG = 0
LOGLEVELINFO = 1
LOGLEVELERROR = 2

basePath = '/var/www/html/openWB'
shconfigfile = basePath+'/smarthome.ini'
os.chdir(basePath)
config = configparser.ConfigParser()
config.read(shconfigfile)
prefixpy = basePath+'/modules/smarthome/'
loglevel=2
maxspeicher = 100
oldmaxspeicher = 0
oldtotalwatt = 0
oldtotalwattot = 0
olduberschuss = 0
olduberschussoffset = 0
numberOfSupportedDevices=9 # limit number of smarthome devices
DeviceValues = { }
DeviceTempValues = { }
DeviceCounters = { }
DeviceConfigured = []
DeviceConfiguredOld = []

for i in range(1, (numberOfSupportedDevices+1)):
    DeviceTempValues.update({'oldw'+str(i) : '2'})
    DeviceTempValues.update({'oldwh'+str(i) : '2'})
    DeviceTempValues.update({'oldtemp'+str(i) : '2'})
    DeviceTempValues.update({'oldtime'+str(i) : '2'})
    DeviceTempValues.update({'oldrelais'+str(i) : '2'})
    DeviceValues.update({ str(i)+"runningtime" : int(0)})
    DeviceValues.update( {str(i)+"WHImported_tmp" : int(0)})
    DeviceConfigured.append("0")
    DeviceConfiguredOld.append("9")

global numberOfDevices

def cleardef(nummer):
    logDebug(LOGLEVELINFO, "(" + str(nummer) + ") Device nicht (mehr) definiert. MQTT auf 0 gesetzt ")
    client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/RelayStatus", "0", qos=0, retain=True)
    client.loop(timeout=2.0)
    client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/Watt", "0", qos=0, retain=True)
    client.loop(timeout=2.0)
    client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/RunningTimeToday", "0", qos=0, retain=True)
    client.loop(timeout=2.0)
    try:
        DeviceValues.update({str(nummer) + "runningtime" : '0'})
    except:
        pass
    if (nummer == 1) or (nummer == 2):
        client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/TemperatureSensor0", "300", qos=0, retain=True)
        client.loop(timeout=2.0)
        client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/TemperatureSensor1", "300", qos=0, retain=True)
        client.loop(timeout=2.0)
        client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/TemperatureSensor2", "300", qos=0, retain=True)
        client.loop(timeout=2.0)
    f = open(basePath+'/ramdisk/device' + str(nummer) + '_watt', 'w')
    f.write(str("0"))
    f.close()
    f = open(basePath+'/ramdisk/device' + str(nummer) + '_relais', 'w')
    f.write(str("0"))
    f.close()
    try:
        del DeviceCounters[str(nummer)+"oldstampeinschaltdauer"]
    except:
        pass
    if os.path.isfile(basePath+'/ramdisk/smarthome_device_'+str(nummer)+'sec0'):
        os.remove(basePath+'/ramdisk/smarthome_device_'+str(nummer)+'sec0')
        logDebug(LOGLEVELINFO, "(" + str(nummer) + ") Device nicht (mehr) definiert. Simcount aktuelle Leistung gelöscht ")
def gettyp(nummer):
    try:
        smarttype =  str(config.get('smarthomedevices', 'device_type_'+str(nummer)))
    except:
        smarttype = 'none'
    if (smarttype == "none"):
        return (smarttype, 0)
    try:
        canswitch = int(config.get('smarthomedevices', 'device_canswitch_'+str(nummer)))
    except:
        canswitch = 1
    return (smarttype, canswitch)
def checkbootdone():
    try:
        with open(basePath+'/ramdisk/bootinprogress', 'r') as value:
            bootinprogress = int(value.read())
    except Exception as e:
        bootinprogress = 1
        logDebug(LOGLEVELERROR, "Ramdisk not set up. Maybe we are still booting (bootinprogress)." + str(e))
        time.sleep(30)
        return 0
    try:
        with open(basePath+'/ramdisk/updateinprogress', 'r') as value:
            updateinprogress = int(value.read())
    except Exception as e:
        updateinprogress = 1
        logDebug(LOGLEVELERROR, "Ramdisk not set up. Maybe we are still booting (updateinprogress)." + str(e))
        time.sleep(30)
        return 0
    if (updateinprogress == 1):
        logDebug(LOGLEVELERROR, "Update in progress.")
        time.sleep(30)
        return 0
    if (bootinprogress == 1):
        logDebug(LOGLEVELERROR, "Boot in progress.")
        time.sleep(30)
        return 0
    return 1
#art der Ueberschussberechnung lesen, relevanten ueberschuss zurueckgeben
def getueb(nummer):
#    (1 = mit Speicher, 2 = mit offset , 0 = manual eingeschaltet)
    ueberschussberechnung = 1
    if os.path.isfile(basePath+'/ramdisk/device' + str(nummer) + '_ueberschuss'):
        f = open(basePath+'/ramdisk/device' + str(nummer) + '_ueberschuss', 'r')
        ueberschussberechnung=int(f.read())
        f.close()
    if (ueberschussberechnung == 2):
        return (uberschussoffset,2)
    else:
        return (uberschuss,1)
# setze art der Ueberschussrechnung
def setueb(nummer,ueberschussberechnung):
#    (1 = mit Speicher, 2 = mit offset, 0 = manual eingeschaltet)
    f = open(basePath+'/ramdisk/device' + str(nummer) + '_ueberschuss', 'w')
    f.write(str(ueberschussberechnung))
    f.close()
# support old smarttypes and new smarttypes
def getdir(smarttype,name):
    if (smarttype == "shelly"):
        dirname = prefixpy + 'shelly'
        return dirname
    if (smarttype == "tasmota"):
        dirname = prefixpy + 'tasmota'
        return dirname
    if (smarttype == "pyt"):
        dirname = prefixpy + name.lower()
        return dirname
    if (smarttype == "avm"):
        dirname = prefixpy + 'avmhomeautomation'
        return dirname
    dirname = prefixpy + smarttype.lower()
    return dirname
def sepwatt(oldwatt,oldwattk,nummer):
    try:
        difmes = int(config.get('smarthomedevices', 'device_differentmeasurement_'+str(nummer)))
    except:
        difmes = 0
    try:
        configuredName = config.get('smarthomedevices', 'device_name_'+str(nummer))
    except:
        configuredName = "(unknown name)"
    if difmes == 0:
        newwatt = oldwatt
       # simcount verwenden wenn newwattk = 0
        newwattk = oldwattk
        return (newwatt, newwattk)
    try:
        meastyp = str(config.get('smarthomedevices', 'device_measuretype_'+str(nummer)))
    except:
        meastyp = "undef"
    logDebug(LOGLEVELDEBUG, "(" + str(nummer) + ") Leistungsmessung durch " +  meastyp)
    argumentList = ['python3', 'undef', str(nummer)]
    try:
        argumentList.append(config.get('smarthomedevices', 'device_measureip_'+str(nummer)))
    except:
        argumentList.append("undef")
    (devuberschuss,ueberschussberechnung )= getueb(nummer)
    argumentList.append(str(devuberschuss))
    if meastyp == "sdm630":
        argumentList[1] = prefixpy +'sdm630/sdm630.py'
        argumentList[4] = config.get('smarthomedevices', 'device_measureid_'+str(nummer)) # replace uberschuss as third command line parameter with measureid
    elif meastyp == "shelly":
        argumentList[1] = prefixpy + 'shelly/watt.py'
    elif meastyp == "mystrom":
        argumentList[1] = prefixpy + 'mystrom/watt.py'
    elif meastyp == "http":
        argumentList[1] = prefixpy + 'http/watt.py'
        try:
            measureurl = str(config.get('smarthomedevices', 'device_measureurl_'+str(nummer)))
            argumentList.append(measureurl)
        except:
            argumentList.append("undef")
        try:
            measureurlc = str(config.get('smarthomedevices', 'device_measureurlc_'+str(nummer)))
            argumentList.append(measureurlc)
        except:
            argumentList.append("none")
    else:
       # no known meastyp, so return the old values directly
        logDebug(LOGLEVELERROR, "Leistungsmessung %s %d %s Geraetetyp ist nicht implementiert!" % (meastyp, nummer, str(configuredName)))
        newwatt = oldwatt
        newwattk = oldwattk
        return (newwatt, newwattk)
    # now we have everthing we need to call the subprocess
    try:
        proc = subprocess.Popen(argumentList)
        proc.communicate()
        f1 = open(basePath+'/ramdisk/smarthome_device_ret' + str(nummer) , 'r')
        answerj = json.load(f1)
        f1.close()
        answer = json.loads(answerj)
        newwatt = int(answer['power'])
        newwattk = int(answer['powerc'])
    except Exception as e1:
        DeviceValues.update( {str(nummer) : "error"})
        logDebug(LOGLEVELERROR, "Leistungsmessung %s %d %s Fehlermeldung: %s " % (meastyp, nummer, str(configuredName), str(e1)))
        raise Exception("error in sepwatt")
    return (newwatt, newwattk)
def logDebug(level, msg):
    if (int(level) >= int(loglevel)):
        local_time = datetime.now(timezone.utc).astimezone()
        file = open(basePath+'/ramdisk/smarthome.log', 'a',encoding='utf8')
        if (int(level) == 0):
            file.write(local_time.strftime(format = "%Y-%m-%d %H:%M:%S") + ': ' + str(msg)+ '\n')
        if (int(level) == 1):
            file.write(local_time.strftime(format = "%Y-%m-%d %H:%M:%S") + ': ' + str(msg)+ '\n')
        if (int(level) == 2):
            file.write(local_time.strftime(format = "%Y-%m-%d %H:%M:%S") + ': ' + str(msg)+ '\n')
        file.close()
def simcount(watt2, pref, importfn, exportfn, nummer,wattks):
    # Zaehler mitgeliefert in WH , zurueckrechnen fuer simcount
    if wattks > 0:
        wattposkh=wattks
        wattnegkh=0
        wattposh=wattks * 3600
        wattnegh= 0
        f = open(basePath+'/ramdisk/'+pref+'watt0pos', 'w')
        f.write(str(wattposh))
        f.close()
        DeviceValues.update( {str(nummer) + "wpos" : wattposh})
        f = open(basePath+'/ramdisk/'+pref+'watt0neg', 'w')
        f.write(str(wattnegh))
        f.close()
        f = open(basePath+'/ramdisk/'+ importfn,'w')
        #    f = open(basePath+'/ramdisk/speicherikwh', 'w')
        DeviceValues.update( {str(nummer) + "wh" : round(wattposkh, 2)})
        f.write(str(round(wattposkh, 2)))
        f.close()
        f = open(basePath+'/ramdisk/' +exportfn , 'w')
        #   f = open(basePath+'/ramdisk/speicherekwh', 'w')
        f.write(str(wattnegkh))
        f.close()
        return
    # emulate import  export
    seconds2= time.time()
    watt1=0
    seconds1=0.0
    if os.path.isfile(basePath+'/ramdisk/'+pref+'sec0'):
        f = open(basePath+'/ramdisk/'+pref+'sec0', 'r')
        seconds1=float(f.read())
        f.close()
        f = open(basePath+'/ramdisk/'+pref+'wh0', 'r')
        watt1=int(f.read())
        f.close()
        f = open(basePath+'/ramdisk/'+pref+'watt0pos', 'r')
        wattposh=int(f.read())
        f.close()
        f = open(basePath+'/ramdisk/'+pref+'watt0neg', 'r')
        wattnegh=int(f.read())
        f.close()
        f = open(basePath+'/ramdisk/'+pref+'sec0', 'w')
        value1 = "%22.6f" % seconds2
        f.write(str(value1))
        f.close()
        f = open(basePath+'/ramdisk/'+pref+'wh0', 'w')
        f.write(str(watt2))
        f.close()
        seconds1=seconds1+1
        deltasec = seconds2- seconds1
        deltasectrun =int(deltasec* 1000) / 1000
        stepsize = int((watt2-watt1)/deltasec)
        while seconds1 <= seconds2:
            if watt1 < 0:
                wattnegh= wattnegh + watt1
            else:
                wattposh= wattposh + watt1
            watt1 = watt1 + stepsize
            if stepsize < 0:
                watt1 = max(watt1,watt2)
            else:
                watt1 = min(watt1,watt2)
            seconds1= seconds1 +1
        rest= deltasec - deltasectrun
        seconds1= seconds1  - 1 + rest
        if rest > 0:
            watt1 = int(watt1 * rest)
            if watt1 < 0:
                wattnegh= wattnegh + watt1
            else:
                wattposh= wattposh + watt1
        wattposkh=wattposh/3600
        wattnegkh=(wattnegh*-1)/3600
        f = open(basePath+'/ramdisk/'+pref+'watt0pos', 'w')
        f.write(str(wattposh))
        f.close()
        DeviceValues.update( {str(nummer) + "wpos" : wattposh})
        f = open(basePath+'/ramdisk/'+pref+'watt0neg', 'w')
        f.write(str(wattnegh))
        f.close()
        f = open(basePath+'/ramdisk/'+ importfn,'w')
        #    f = open(basePath+'/ramdisk/speicherikwh', 'w')
        DeviceValues.update( {str(nummer) + "wh" : round(wattposkh, 2)})
        f.write(str(round(wattposkh, 2)))
        f.close()
        f = open(basePath+'/ramdisk/' +exportfn , 'w')
        #   f = open(basePath+'/ramdisk/speicherekwh', 'w')
        f.write(str(wattnegkh))
        f.close()
    else:
        f = open(basePath+'/ramdisk/'+pref+'sec0', 'w')
        value1 = "%22.6f" % seconds2
        f.write(str(value1))
        f.close()
        f = open(basePath+'/ramdisk/'+pref+'wh0', 'w')
        f.write(str(watt2))
        f.close()

def publishmqtt():
    global oldmaxspeicher
    global oldtotalwatt
    global oldtotalwattot
    global olduberschuss
    global olduberschussoffset
    global totalwatt
    global totalwattot
    client = mqtt.Client("openWB-SmartHome-bulkpublisher-" + str(os.getpid()))
    client.connect("localhost")
    for key in DeviceValues:
        if ( "relais" in key):
            nummer = int(list(filter(str.isdigit, key))[0])
            if ( DeviceValues[str(key)] != DeviceTempValues['oldrelais' + str(nummer)]):
                client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/RelayStatus", payload=DeviceValues[str(key)], qos=0, retain=True)
                client.loop(timeout=2.0)
                DeviceTempValues.update({'oldrelais'+str(nummer) : DeviceValues[str(key)]})
        if ( "time" in key):
            nummer = str(list(filter(str.isdigit, key))[0])
            if ( DeviceValues[str(key)] != DeviceTempValues['oldtime' + str(nummer)]):
                client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/RunningTimeToday", payload=DeviceValues[str(key)], qos=0, retain=True)
                DeviceTempValues.update({'oldtime'+str(nummer) : DeviceValues[str(key)]})
        if ( "temp" in key):
            nummer = str(list(filter(str.isdigit, key))[0])
            if ( DeviceValues[str(key)] != DeviceTempValues['oldtemp' + str(nummer)]):
                sensor = str(list(filter(str.isdigit, key))[1])
                client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/TemperatureSensor"+str(sensor), payload=DeviceValues[str(key)], qos=0, retain=True)
                DeviceTempValues.update({'oldtemp'+str(nummer) : DeviceValues[str(key)]})
        if ( "watt" in key):
            nummer = int(list(filter(str.isdigit, key))[0])
            if ( DeviceValues[str(key)] != DeviceTempValues['oldw' + str(nummer)]):
                client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/Watt", payload=DeviceValues[str(key)], qos=0, retain=True)
                client.loop(timeout=2.0)
                DeviceTempValues.update({'oldw'+str(nummer) : DeviceValues[str(key)]})
        if ( "wh" in key):
            nummer = int(list(filter(str.isdigit, key))[0])
            if ( DeviceValues[str(key)] != DeviceTempValues['oldwh' + str(nummer)]):
                client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/Wh", payload=DeviceValues[str(key)], qos=0, retain=True)
                client.loop(timeout=2.0)
                DeviceTempValues.update({'oldwh'+str(nummer) : DeviceValues[str(key)]})
        if ( "wpos" in key):
            nummer = int(list(filter(str.isdigit, key))[0])
            client.publish("openWB/SmartHome/Devices/"+str(nummer)+"/WHImported_temp", payload=DeviceValues[str(key)], qos=0, retain=True)
            client.loop(timeout=2.0)
    if (oldmaxspeicher != maxspeicher):
        client.publish("openWB/SmartHome/Status/maxspeicherladung", payload=str(maxspeicher), qos=0, retain=True)
        client.loop(timeout=2.0)
        oldmaxspeicher = maxspeicher
    if (oldtotalwatt != totalwatt):
        client.publish("openWB/SmartHome/Status/wattschalt", payload=str(totalwatt), qos=0, retain=True)
        client.loop(timeout=2.0)
        oldtotalwatt = totalwatt
    if (oldtotalwattot != totalwattot):
        client.publish("openWB/SmartHome/Status/wattnichtschalt", payload=str(totalwattot), qos=0, retain=True)
        client.loop(timeout=2.0)
        oldtotalwattot = totalwattot
    if (olduberschuss != uberschuss):
        client.publish("openWB/SmartHome/Status/uberschuss", payload=str(uberschuss), qos=0, retain=True)
        client.loop(timeout=2.0)
        olduberschuss = uberschuss
    if (olduberschussoffset != uberschussoffset):
        client.publish("openWB/SmartHome/Status/uberschussoffset", payload=str(uberschussoffset), qos=0, retain=True)
        client.loop(timeout=2.0)
        olduberschussoffset = uberschussoffset
    client.disconnect()
# Lese aus der Ramdisk Regelrelevante Werte ein
def loadregelvars():
    global uberschuss
    global uberschussoffset
    global speicherleistung
    global speichersoc
    global speichervorhanden
    global loglevel
    global reread
    global wattbezug
    global numberOfSupportedDevices
    global maxspeicher
    try:
        with open(basePath+'/ramdisk/speichervorhanden', 'r') as value:
            speichervorhanden = int(value.read())
        if ( speichervorhanden == 1):
            with open(basePath+'/ramdisk/speicherleistung', 'r') as value:
                speicherleistung = int(float(value.read()))
            with open(basePath+'/ramdisk/speichersoc', 'r') as value:
                speichersoc = int(float(value.read()))
        else:
            speicherleistung = 0
            speichersoc = 100
    except Exception as e:
        logDebug(LOGLEVELERROR, "Fehler beim Auslesen der Ramdisk (speichervorhanden,speicherleistung,speichersoc): " + str(e))
        speichervorhanden = 0
        speicherleistung = 0
        speichersoc = 100
    try:
        with open(basePath+'/ramdisk/wattbezug', 'r') as value:
            wattbezug = int(float(value.read())) * -1
    except Exception as e:
        logDebug(LOGLEVELERROR, "Fehler beim Auslesen der Ramdisk (wattbezug): " + str(e))
        wattbezug = 0
    uberschuss = wattbezug + speicherleistung
    try:
        with open(basePath+'/ramdisk/smarthomehandlermaxbatterypower', 'r') as value:
            maxspeicher = int(value.read())
    except Exception as e:
        logDebug(LOGLEVELERROR, "Fehler beim Auslesen der Ramdisk (smarthomehandlermaxbatterypower): " + str(e))
        maxspeicher = 0
    uberschussoffset = wattbezug + speicherleistung - maxspeicher
    try:
        with open('ramdisk/smarthomehandlerloglevel', 'r') as value:
            loglevel = int(value.read())
    except:
            loglevel=2
            f = open(basePath+'/ramdisk/smarthomehandlerloglevel', 'w')
            f.write(str(2))
            f.close()
    try:
        with open('ramdisk/rereadsmarthomedevices', 'r') as value:
            reread = int(value.read())
    except:
        reread = 1
        config.read(shconfigfile)
    if ( reread == 1):
        config.read(shconfigfile)
        f = open(basePath+'/ramdisk/rereadsmarthomedevices', 'w')
        f.write(str(0))
        f.close()
        logDebug(LOGLEVELERROR, "Config reRead")
    for i in range(1, (numberOfSupportedDevices+1)):
        try:
            with open('ramdisk/smarthome_device_manual_' + str(i), 'r') as value:
                DeviceValues.update( {str(i) + "manual": int(value.read())})
        except:
            DeviceValues.update( {str(i) + "manual": 0})
    for i in range(1, (numberOfSupportedDevices+1)):
        try:
            with open('ramdisk/smarthome_device_manual_control_' + str(i), 'r') as value:
                DeviceValues.update( {str(i) + "manualmodevar": int(value.read())})
        except:
            DeviceValues.update( {str(i) + "manualmodevar": 2})
    logDebug(LOGLEVELDEBUG, "EVU Bezug(-)/Einspeisung(+): " + str(wattbezug) + " max Speicherladung: " + str(maxspeicher))
    logDebug(LOGLEVELDEBUG, "Uberschuss: " + str(uberschuss)  + " Uberschuss mit Offset: " + str(uberschussoffset) )
    logDebug(LOGLEVELDEBUG, "Speicher Entladung(-)/Ladung(+): " + str(speicherleistung) + " SpeicherSoC: " + str(speichersoc))
    f = open(basePath+'/ramdisk/devicemaxspeicher', 'w')
    f.write(str(maxspeicher))
    f.close()
def on_connect(client, userdata, flags, rc):
    client.subscribe("openWB/SmartHome/#", 2)

def on_message(client, userdata, msg):
    global numberOfSupportedDevices
    if (( "openWB/SmartHome/Device" in msg.topic) and ("WHImported_temp" in msg.topic)):
        devicenumb=re.sub(r'\D', '', msg.topic)
        if ( 1 <= int(devicenumb) <= numberOfSupportedDevices ):
            DeviceValues.update( {str(devicenumb)+"WHImported_tmp": int(msg.payload)})
    if (( "openWB/SmartHome/Device" in msg.topic) and ("RunningTimeToday" in msg.topic)):
        devicenumb=re.sub(r'\D', '', msg.topic)
        if ( 1 <= int(devicenumb) <= numberOfSupportedDevices ):
            DeviceValues.update( {str(devicenumb)+"runningtime": int(msg.payload)})
# Auslesen des Smarthome Devices (Watt und/oder Temperatur)
def getdevicevalues():
    global totalwatt
    global totalwattot
    for i in range(1, (numberOfSupportedDevices+1)):
        DeviceConfigured[i-1] = config.get('smarthomedevices', 'device_configured_'+str(i)) # list starts at 0
        if (DeviceConfigured[i-1] != DeviceConfiguredOld[i-1]) and (DeviceConfigured[i-1] == "0"):
            cleardef(i)
        DeviceConfiguredOld[i-1] = DeviceConfigured[i-1]
    numberOfDevices = 0
    totalwatt = 0
    totalwattot = 0
    for n in DeviceConfigured:
        numberOfDevices += 1
        # prepare
        abschalt = 0
        try:
            deactivatewhileevcharging = int(config.get('smarthomedevices', 'device_deactivatewhileevcharging_'+str(numberOfDevices)))
        except:
            deactivatewhileevcharging = 0
        try:
            mineinschaltdauer = int(config.get('smarthomedevices', 'device_mineinschaltdauer_'+str(numberOfDevices))) * 60
        except:
            mineinschaltdauer = 0
        if deactivatewhileevcharging == 1:
            if str(numberOfDevices)+"eintime" in DeviceCounters:
                timestart = int(time.time()) - int(DeviceCounters[str(numberOfDevices)+"eintime"])
                if ( mineinschaltdauer < timestart):
                    abschalt = 1
                else:
                    abschalt = 0
            else:
                abschalt = 1
        # prepare end
        if ( n == "1" ):
            #alle devices laufen gleich
            (switchtyp,canswitch) = gettyp(numberOfDevices)
            devicename = str(config.get('smarthomedevices', 'device_name_'+str(numberOfDevices)))
            (devuberschuss,ueberschussberechnung) = getueb(numberOfDevices)
            try:
                device_leistungurl = str(config.get('smarthomedevices', 'device_leistungurl_'+str(numberOfDevices)))
            except:
                device_leistungurl = "undef"
            try:
                device_actor = str(config.get('smarthomedevices','device_actor_'+str(numberOfDevices)))
            except:
                device_actor = "undef"
            try:
                device_username = str(config.get('smarthomedevices','device_username_'+str(numberOfDevices)))
            except:
                device_username = "undef"
            try:
                device_password = str(config.get('smarthomedevices','device_password_'+str(numberOfDevices)))
            except:
                device_password = "undef"
            try:
                device_ip = str(config.get('smarthomedevices', 'device_ip_'+str(numberOfDevices)))
            except:
                device_ip = "undef"
            try:
                device_acthortype = str(config.get('smarthomedevices', 'device_acthortype_'+str(numberOfDevices)))
            except:
                device_acthortype = "undef"
            try:
                device_acthorpower = int(config.get('smarthomedevices', 'device_acthorpower_'+str(numberOfDevices)))
            except:
                device_acthorpower = 0
            pyname0 = getdir(switchtyp,devicename)
            try:
                pyname = pyname0 +"/watt.py"
                if os.path.isfile(pyname) and (switchtyp != "none"):
                    argumentList = ['python3', pyname, str(numberOfDevices)]
                    argumentList.append(device_ip)
                    argumentList.append(str(devuberschuss))
                    if (switchtyp == "acthor"):
                        argumentList.append(device_acthortype)
                        argumentList.append(str(device_acthorpower))
                    else:
                        argumentList.append(device_leistungurl)
                        argumentList.append(device_actor)
                    argumentList.append(device_username)
                    argumentList.append(device_password)
                    proc=subprocess.Popen(argumentList)
                    proc.communicate()
                    f1 = open(basePath+'/ramdisk/smarthome_device_ret' +str(numberOfDevices) , 'r')
                    answerj=json.load(f1)
                    f1.close()
                    answer = json.loads(answerj)
                    wattstart = int(answer['power'])
                    wattkstart = int(answer['powerc'])
                    if (int(answer['on']) == 1):
                        relais=1
                    else:
                        relais=0
                    #Shelly temp sensor
                    if (switchtyp == "shelly")  and (canswitch == 1):
                        try:
                            anzahltemp = int(config.get('smarthomedevices', 'device_temperatur_configured_'+str(numberOfDevices)))
                            if ( anzahltemp > 0):
                                for i in range(anzahltemp):
                                    temp = str(answer['temp' +  str(i)])
                                    logDebug(LOGLEVELERROR, "(" + str(numberOfDevices) + ") Shelly temp sensor: " + str(i+1) + " Grad: " +  temp)
                                    DeviceValues.update( {str(numberOfDevices) + "temp" + str(i) : temp })
                                    f = open(basePath+'/ramdisk/device' + str(numberOfDevices) + '_temp'+ str(i), 'w')
                                    f.write(str(temp))
                                    f.close()
                        except:
                            pass
                    #mystrom temp sensor
                    if (switchtyp == "mystrom")  and (canswitch == 1):
                        temp = str(answer['temp0'])
                        logDebug(LOGLEVELERROR, "(" + str(numberOfDevices) + ") mystrom temp sensor: 1 Grad: " +  temp)
                        DeviceValues.update( {str(numberOfDevices) + "temp0"  : temp })
                        f = open(basePath+'/ramdisk/device' + str(numberOfDevices) + '_temp0', 'w')
                        f.write(str(temp))
                        f.close()
                else:
                    wattstart = 0
                    wattkstart = 0
                    relais = 0
                   # only relevant for canswitch == 1, file not found
                    if (canswitch == 1):
                        logDebug(LOGLEVELDEBUG, "Device " + str(switchtyp) + str(numberOfDevices) + str(devicename) + " File not found: " + str(pyname))
                # Separate Leistungs messung ?
                (watt,wattk) = sepwatt(wattstart,wattkstart,numberOfDevices)
                if abschalt == 1:
                    totalwatt = totalwatt + watt
                else:
                    totalwattot = totalwattot + watt
                DeviceValues.update( {str(numberOfDevices) + "watt" : watt})
                DeviceValues.update( {str(numberOfDevices) + "relais" : relais})
                f = open(basePath+'/ramdisk/device' + str(numberOfDevices) + '_watt', 'w')
                f.write(str(watt))
                f.close()
                f = open(basePath+'/ramdisk/device' + str(numberOfDevices) + '_relais', 'w')
                f.write(str(relais))
                f.close()
                try:
                    with open(basePath+'/ramdisk/smarthome_device_' + str(numberOfDevices) + 'watt0pos', 'r') as value:
                        importtemp = int(value.read())
                    simcount(watt, "smarthome_device_"+ str(numberOfDevices), "device"+ str(numberOfDevices)+"_wh" ,"device"+ str(numberOfDevices)+"_whe", str(numberOfDevices),wattk)
                   #importtemp1 = int(DeviceValues[str(numberOfDevices)+"wpos"]) # unused variable
                except Exception as e:
                    importtemp = int(DeviceValues[str(numberOfDevices)+"WHImported_tmp"])
                    f = open(basePath+'/ramdisk/smarthome_device_' + str(numberOfDevices) + 'watt0pos', 'w')
                    f.write(str(importtemp))
                    f.close()
                    f = open(basePath+'/ramdisk/smarthome_device_' + str(numberOfDevices) + 'watt0neg', 'w')
                    f.write(str("0"))
                    f.close()
                #Update Einschaltdauer Timer
                if ( relais == 1):
                    newtime = int(time.time())
                    try:
                        if str(numberOfDevices)+"oldstampeinschaltdauer" in DeviceCounters:
                            timediff = newtime - DeviceCounters[str(numberOfDevices)+"oldstampeinschaltdauer"]
                            try:
                                DeviceValues[str(numberOfDevices)+"runningtime"]= DeviceValues[str(numberOfDevices)+"runningtime"] + int(timediff)
                            except Exception as e:
                                DeviceValues.update( {str(numberOfDevices) + "runningtime" : int(0)})
                            DeviceCounters.update( {str(numberOfDevices) + "oldstampeinschaltdauer" : newtime})
                        else:
                            DeviceCounters.update( {str(numberOfDevices) + "oldstampeinschaltdauer" : newtime})
                    except Exception as e:
                       logDebug(LOGLEVELERROR, "Device " + str(switchtyp) + str(numberOfDevices) + str(devicename) + " (Einschaltdauer)Fehlermeldung: " + str(e))
                else:
                    try:
                        del DeviceCounters[str(numberOfDevices)+"oldstampeinschaltdauer"]
                    except:
                        pass
                #Einschaltzeit des Relais setzen
                if str(numberOfDevices)+"relais" in DeviceValues:
                    if ( DeviceValues[str(numberOfDevices)+"relais"] == 0 ):
                        if ( relais == 1 ):
                            DeviceCounters.update( {str(numberOfDevices) + "eintime" : time.time()})
                    else:
                        if ( relais == 0 ):
                            if str(numberOfDevices) + "eintime" in DeviceCounters:
                                del DeviceCounters[str(numberOfDevices) + "eintime"]
                DeviceValues.update( {str(numberOfDevices) + "relais" : relais})
                logDebug(LOGLEVELDEBUG, "(" + str(numberOfDevices) + ") " + str(devicename) + " relais: " + str(relais)  + " aktuell: " + str(watt) + " Zaehler Hw: " + str(wattk))
            except Exception as e:
                DeviceValues.update( {str(numberOfDevices) : "error"})
                logDebug(LOGLEVELERROR, "Device " + str(switchtyp) + str(numberOfDevices) + str(devicename) + " Fehlermeldung: " + str(e))
    f = open(basePath+'/ramdisk/devicetotal_watt', 'w')
    f.write(str(totalwatt))
    f.close()
    f = open(basePath+'/ramdisk/devicetotal_watt_other', 'w')
    f.write(str(totalwattot))
    f.close()
    logDebug(LOGLEVELDEBUG, "Total Watt abschaltbarer smarthomedevices: " + str(totalwatt)  )
    logDebug(LOGLEVELDEBUG, "Total Watt nichtabschaltbarer smarthomedevices: " + str(totalwattot) )
    publishmqtt()

def turndevicerelais(nummer, zustand,ueberschussberechnung):
    (switchtyp,canswitch) = gettyp(nummer)
    devicename = str(config.get('smarthomedevices', 'device_name_'+str(nummer)))
    try:
        device_einschalturl = str(config.get('smarthomedevices', 'device_einschalturl_'+str(nummer)))
    except:
        device_einschalturl = "undef"
    try:
        device_ausschalturl = str(config.get('smarthomedevices', 'device_ausschalturl_'+str(nummer)))
    except:
        device_ausschalturl = "undef"
    try:
        device_actor = str(config.get('smarthomedevices','device_actor_'+str(nummer)))
    except:
        device_actor = "undef"
    try:
        device_username = str(config.get('smarthomedevices','device_username_'+str(nummer)))
    except:
        device_username = "undef"
    try:
        device_password = str(config.get('smarthomedevices','device_password_'+str(nummer)))
    except:
        device_password = "undef"
    pyname0 = getdir(switchtyp,devicename)
    setueb(nummer,ueberschussberechnung)
    (devuberschuss, ueberschussberechnung) = getueb(nummer)
    argumentList = ['python3', "", str(nummer)] # element with index 1 will be set to on.py or off.py
    argumentList.append(config.get('smarthomedevices', 'device_ip_'+str(nummer)))
    argumentList.append(str(devuberschuss))
    argumentList.append("") # element with index 5 will be set on URL for switch on or off
    argumentList.append(device_actor)
    argumentList.append(device_username)
    argumentList.append(device_password)
    if ( zustand == 1):
        try:
            pyname = pyname0 +"/on.py"
            if os.path.isfile(pyname):
                argumentList[1] = pyname
                argumentList[5] = device_einschalturl
                logDebug(LOGLEVELINFO, "(" + str(nummer) + ") " + str(devicename) + " angeschaltet. Ueberschussberechnung (1 = mit Speicher, 2 = mit Offset) " + str(ueberschussberechnung) )
                f = open(basePath+'/ramdisk/device' + str(nummer) + '_req_relais', 'w')
                f.write(str(zustand))
                f.close()
                DeviceCounters.update( {str(nummer) + "eintime" : time.time()})
                proc=subprocess.Popen(argumentList)
                proc.communicate()
            else:
               logDebug(LOGLEVELDEBUG, "Device " + str(switchtyp) + str(nummer) + str(devicename) + " File not found: " + str(pyname))
        except Exception as e:
            logDebug(LOGLEVELERROR, "Fehler beim Einschalten von (" + str(nummer) + ") Fehlermeldung: " + str(e))
    if ( zustand == 0):
        try:
            pyname = pyname0 +"/off.py"
            if os.path.isfile( pyname  ):
                argumentList[1] = pyname
                argumentList[5] = device_ausschalturl
                proc=subprocess.Popen(argumentList)
                proc.communicate()
                logDebug(LOGLEVELINFO, "(" + str(nummer) + ") " + str(devicename) + " ausgeschaltet")
                f = open(basePath+'/ramdisk/device' + str(nummer) + '_req_relais', 'w')
                f.write(str(zustand))
                f.close()
            else:
                logDebug(LOGLEVELDEBUG, "Device " + str(switchtyp) + str(nummer) + str(devicename) + " File not found: " + str(pyname))
        except Exception as e:
            logDebug(LOGLEVELERROR, "Fehler beim Ausschalten von (" + str(nummer) + ") Fehlermeldung: " + str(e))
def conditions(nummer):
    try:
        speichersocbeforestop = int(config.get('smarthomedevices', 'device_speichersocbeforestop_'+str(nummer)))
    except:
        speichersocbeforestop = 100
    try:
        speichersocbeforestart = int(config.get('smarthomedevices', 'device_speichersocbeforestart_'+str(nummer)))
    except:
        speichersocbeforestart = 0
    try:
        deactivatewhileevcharging = int(config.get('smarthomedevices', 'device_deactivatewhileevcharging_'+str(nummer)))
    except:
        deactivatewhileevcharging = 0
    file_charge= '/var/www/html/openWB/ramdisk/llkombiniert'
    testcharge = 0
    if os.path.isfile(file_charge):
        f = open( file_charge, 'r')
        testcharge =int(f.read())
        f.close()
    if testcharge == 0:
        chargestatus = 0
    else:
        chargestatus = 1
    einschwelle = int(config.get('smarthomedevices', 'device_einschaltschwelle_'+str(nummer)))
    ausschwelle = int(config.get('smarthomedevices', 'device_ausschaltschwelle_'+str(nummer))) * -1
    einverz = int(config.get('smarthomedevices', 'device_einschaltverzoegerung_'+str(nummer))) * 60
    ausverz = int(config.get('smarthomedevices', 'device_ausschaltverzoegerung_'+str(nummer))) * 60
    mineinschaltdauer = int(config.get('smarthomedevices', 'device_mineinschaltdauer_'+str(nummer))) * 60
    maxeinschaltdauer = int(config.get('smarthomedevices', 'device_maxeinschaltdauer_'+str(nummer))) * 60
    name = str(config.get('smarthomedevices', 'device_name_'+str(nummer)))
    if ( maxeinschaltdauer > int(DeviceValues[str(nummer)+"runningtime"])):
        logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Maximale Einschaltdauer nicht erreicht")
    else:
        if ( DeviceValues[str(nummer)+"relais"] == 1 ):
            logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name) + " Maximale Einschaltdauer erreicht schalte ab")
            turndevicerelais(nummer, 0,0)
        else:
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ")" + str(name) + " Maximale Einschaltdauer erreicht bereits abgeschaltet")
        return
    # Auto ladung
    if deactivatewhileevcharging == 1:
        if ( DeviceValues[str(nummer)+"relais"] == 1 ):
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Soll ausgeschaltet werden bei Ladung, pruefe")
            if chargestatus == 1:
                logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Ladung läuft, pruefe Mindestlaufzeit")
                if str(nummer)+"eintime" in DeviceCounters:
                    timestart = int(time.time()) - int(DeviceCounters[str(nummer)+"eintime"])
                    if ( mineinschaltdauer < timestart):
                        logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)  + " Mindesteinschaltdauer erreicht, schalte aus ")
                        turndevicerelais(nummer, 0,0)
                        return
                    else:
                        logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)  + " Mindesteinschaltdauer nicht erreicht, " + str(mineinschaltdauer) + " > " + str(timestart))
                else:
                    logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)+ " Mindesteinschaltdauer nicht bekannt, schalte aus")
                    turndevicerelais(nummer, 0,0)
                    return
            else:
                logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Ladung läuft nicht, pruefe weiter")
        else:
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Soll nicht eingeschaltet werden bei Ladung, pruefe")
            if chargestatus == 1:
                logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Ladung läuft, wird nicht eingeschaltet")
                return
            else:
                logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Ladung läuft nicht, pruefe weiter")
    # Auto ladung ende
    # Art vom ueberschussberechnung pruefen
    ueberschussberechnung = 0
    oldueberschussberechnung = 0
    devuberschuss = 0
    ( devuberschuss, oldueberschussberechnung)= getueb(nummer)
    if (speichersocbeforestart == 0):
        # Berechnung aus, Ueberschuss mit Speicher nehmen
        devuberschuss = uberschuss
        ueberschussberechnung = 1
    else:
        if ( speichersoc < speichersocbeforestart ) and (speichersoc < 97):
            # unter dem Speicher soc, nur EVU Ueberschuss
            # Berechnung mit Ueberschuss nur mit Speicherentladung
            devuberschuss = uberschussoffset
            ueberschussberechnung = 2
        else:
            # sonst drueber oder gleich Speicher soc Berechnung mit Ueberschuss mit Speicher nehmen
            # oder nehmen wenn speicher fast voll
            devuberschuss = uberschuss
            ueberschussberechnung = 1
    if ( oldueberschussberechnung !=  ueberschussberechnung):
        setueb(nummer,ueberschussberechnung)
        logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " SoC " + str(speichersoc) + " Einschalt SoC " + str(speichersocbeforestart) +  " Ueberschuss " + str(devuberschuss))
        logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " Ueberschussberechnung anders (1 = mit Speicher, 2 = mit Offset) " + str(ueberschussberechnung))
    if ( devuberschuss > einschwelle):
        try:
            del DeviceCounters[str(nummer)+"ausverz"]
        except:
            pass
        logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(config.get('smarthomedevices', 'device_name_'+str(nummer)))+ " Überschuss "  + str(devuberschuss) + " größer Einschaltschwelle" + str(einschwelle) )
        if ( DeviceValues[str(nummer)+"relais"] == 0 ):
            #speichersocbeforestart
            #if ( speichersoc < speichersocbeforestart ):
            #    logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)+ " SoC " + str(speichersoc) + " kleiner als Einschalt SoC " + str(speichersocbeforestart) + " , schalte Gerät nicht ein")
            #    return
            #else:
            #    logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)+ " SoC " + str(speichersoc) + " grösser gleich als Einschalt SoC " + str(speichersocbeforestart) + " , pruefe weiter")
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " SoC " + str(speichersoc) + " Einschalt SoC " + str(speichersocbeforestart) + " Ueberschuss " + str(devuberschuss))
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " Ueberschussberechnung (1 = mit Speicher, 2 = mit Offset) " + str(ueberschussberechnung))
            #speichersocbeforestart
            if  str(nummer)+"einverz" in DeviceCounters:
                timesince = int(time.time()) - int(DeviceCounters[str(nummer)+"einverz"])
                if ( einverz < timesince ):
                    logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)  + " Einschaltverzögerung erreicht, schalte ein " + str(einschwelle))
                    turndevicerelais(nummer, 1,ueberschussberechnung)
                    del DeviceCounters[str(nummer)+"einverz"]
                else:
                    logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name) + " Einschaltverzögerung nicht erreicht. " + str(einverz) + " > " + str(timesince))
            else:
                DeviceCounters.update( {str(nummer) + "einverz" : time.time()})
                logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name) + " Einschaltverzögerung gestartet")
        else:
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " Einschaltverzögerung erreicht, bereits ein")
            try:
                del DeviceCounters[str(nummer)+"einverz"]
            except:
                pass
    else:
        try:
            del DeviceCounters[str(nummer)+"einverz"]
        except:
            pass
        if ( devuberschuss < ausschwelle):
            if ( speichersoc > speichersocbeforestop ):
                logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " SoC höher als Abschalt SoC, lasse Gerät weiterlaufen")
                return
            else:
                logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " SoC niedriger als Abschalt SoC, prüfe weiter")
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " Überschuss " + str(devuberschuss)  + " kleiner Ausschaltschwelle" + str(ausschwelle))
            if ( DeviceValues[str(nummer)+"relais"] == 1 ):
                if  str(nummer)+"ausverz" in DeviceCounters:
                    timesince = int(time.time()) - int(DeviceCounters[str(nummer)+"ausverz"])
                    if ( ausverz < timesince ):
                        if  str(nummer)+"eintime" in DeviceCounters:
                            timestart = int(time.time()) - int(DeviceCounters[str(nummer)+"eintime"])
                            if ( mineinschaltdauer < timestart):
                                logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)  + " Ausschaltverzögerung & Mindesteinschaltdauer erreicht, schalte aus " + str(ausschwelle))
                                turndevicerelais(nummer, 0,0)
                                del DeviceCounters[str(nummer)+"ausverz"]
                            else:
                                logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)  + " Ausschaltverzögerung erreicht, Mindesteinschaltdauer nicht erreicht, " + str(mineinschaltdauer) + " > " + str(timestart))
                        else:
                            logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name)+ " Mindesteinschaltdauer nicht bekannt, schalte aus")
                            turndevicerelais(nummer, 0,0)
                    else:
                        logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name) + " Ausschaltverzögerung nicht erreicht. " + str(ausverz) + " > " + str(timesince))
                else:
                    DeviceCounters.update( {str(nummer) + "ausverz" : time.time()})
                    logDebug(LOGLEVELINFO,"(" + str(nummer) + ") " + str(name) + " Ausschaltverzögerung gestartet")
            else:
                logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name)+ " Ausschaltverzögerung erreicht, bereits aus")
                try:
                    del DeviceCounters[str(nummer)+"ausverz"]
                except:
                    pass
        else:
            logDebug(LOGLEVELDEBUG,"(" + str(nummer) + ") " + str(name) + " Überschuss kleiner als Einschaltschwelle und größer als Ausschaltschwelle. Ueberschuss " + str(devuberschuss) )
            try:
                del DeviceCounters[str(nummer)+"einverz"]
            except:
                pass
            try:
                del DeviceCounters[str(nummer)+"ausverz"]
            except:
                pass

def resetmaxeinschaltdauerfunc():
    global resetmaxeinschaltdauer
    global numberOfSupportedDevices
    hour=time.strftime("%H")
    if (int(hour) == 0):
        try:
            if (int(resetmaxeinschaltdauer) == 0):
                for i in range(1, (numberOfSupportedDevices+1)):
                    DeviceValues.update({str(i) + "runningtime" : '0'})
                resetmaxeinschaltdauer=1
        except:
            resetmaxeinschaltdauer=0
    if (int(hour) == 2):
        resetmaxeinschaltdauer=0

client = mqtt.Client("openWB-mqttsmarthome")
client.on_connect = on_connect
client.on_message = on_message
startTime = time.time()
waitTime = 3
client.connect("localhost")
while True:
    client.loop()
    client.subscribe("openWB/SmartHome/#", 2)
    elapsedTime = time.time() - startTime
    if elapsedTime > waitTime:
        client.disconnect()
        break

while True:
    config.read(shconfigfile)
    bootdone = checkbootdone()
    if (bootdone == 1):
        loadregelvars()
        getdevicevalues()
        resetmaxeinschaltdauerfunc()
        for i in range(1, (numberOfSupportedDevices+1)):
            try:
                configured = config.get('smarthomedevices', 'device_configured_' + str(i))
                if (configured == "1"):
                    if ( DeviceValues[str(i)+"manual"] == 1 ):
                        if ( DeviceValues[str(i)+"manualmodevar"] == 0 ):
                            if ( DeviceValues[str(i)+"relais"] == 1 ):
                                turndevicerelais(i, 0,0)
                        if ( DeviceValues[str(i)+"manualmodevar"] == 1 ):
                            if ( DeviceValues[str(i)+"relais"] == 0 ):
                                turndevicerelais(i, 1,0)
                        logDebug(LOGLEVELDEBUG,"(" + str(i) + ") " + str(config.get('smarthomedevices', 'device_name_'+str(i))) + " manueller Modus aktiviert, keine Regelung")
                    else:
                        (switchtyp,canswitch) = gettyp(i)
                        try:
                            if canswitch == 1:
                                conditions(int(i))
                        except Exception as e:
                            logDebug(LOGLEVELERROR, "Conditions (" + str(i) + ") " + str(config.get('smarthomedevices', 'device_name_'+str(i))) + " Fehlermeldung: " + str(e))
            except Exception as e:
                logDebug(LOGLEVELERROR, "Main routine (" + str(i) + ") " + str(config.get('smarthomedevices', 'device_name_'+str(i))) + " Fehlermeldung: " + str(e))
    #conditions(2)
    #if "2eintime" in DeviceCounters:
    #    print(DeviceCounters["2eintime"])
    time.sleep(5)
    #except:
    #exit()
