/**
 * set of topics that has to be subscribed for the pv-charging settings
 *
 * @author Kevin Wieland
 * @author Michael Ortenstein
 */

// line[0] = topic
// line[1] = load counter (if needed)

var topicsToSubscribe = [
	// global settings
	["openWB/housebattery/boolHouseBatteryConfigured", 0],
	["openWB/config/get/SmartHome/logLevel", 0],
	["openWB/config/get/SmartHome/maxBatteryPower", 0],
	// SmartHome configuration
	["openWB/config/get/SmartHome/Devices/1/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/2/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/3/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/4/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/5/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/6/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/7/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/8/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/9/device_configured", 0],
	["openWB/config/get/SmartHome/Devices/1/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/2/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/3/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/4/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/5/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/6/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/7/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/8/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/9/device_canSwitch", 0],
	["openWB/config/get/SmartHome/Devices/1/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/2/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/3/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/4/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/5/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/6/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/7/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/8/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/9/device_ip", 0],
	["openWB/config/get/SmartHome/Devices/1/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/2/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/3/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/4/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/5/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/6/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/7/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/8/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/9/device_measureip", 0],
	["openWB/config/get/SmartHome/Devices/1/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/2/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/3/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/4/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/5/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/6/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/7/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/8/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/9/device_measureid", 0],
	["openWB/config/get/SmartHome/Devices/1/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/2/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/3/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/4/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/5/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/6/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/7/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/8/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/9/device_differentMeasurement", 0],
	["openWB/config/get/SmartHome/Devices/1/device_name", 0],
	["openWB/config/get/SmartHome/Devices/2/device_name", 0],
	["openWB/config/get/SmartHome/Devices/3/device_name", 0],
	["openWB/config/get/SmartHome/Devices/4/device_name", 0],
	["openWB/config/get/SmartHome/Devices/5/device_name", 0],
	["openWB/config/get/SmartHome/Devices/6/device_name", 0],
	["openWB/config/get/SmartHome/Devices/7/device_name", 0],
	["openWB/config/get/SmartHome/Devices/8/device_name", 0],
	["openWB/config/get/SmartHome/Devices/9/device_name", 0],
	["openWB/config/get/SmartHome/Devices/1/device_type", 0],
	["openWB/config/get/SmartHome/Devices/2/device_type", 0],
	["openWB/config/get/SmartHome/Devices/3/device_type", 0],
	["openWB/config/get/SmartHome/Devices/4/device_type", 0],
	["openWB/config/get/SmartHome/Devices/5/device_type", 0],
	["openWB/config/get/SmartHome/Devices/6/device_type", 0],
	["openWB/config/get/SmartHome/Devices/7/device_type", 0],
	["openWB/config/get/SmartHome/Devices/8/device_type", 0],
	["openWB/config/get/SmartHome/Devices/9/device_type", 0],
	["openWB/config/get/SmartHome/Devices/1/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/2/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/3/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/4/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/5/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/6/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/7/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/8/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/9/device_measureType", 0],
	["openWB/config/get/SmartHome/Devices/1/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/2/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/3/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/4/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/5/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/6/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/7/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/8/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/9/device_einschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/1/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/2/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/3/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/4/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/5/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/6/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/7/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/8/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/9/device_ausschaltschwelle", 0],
	["openWB/config/get/SmartHome/Devices/1/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/2/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/3/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/4/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/5/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/6/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/7/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/8/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/9/device_einschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/1/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/2/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/3/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/4/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/5/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/6/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/7/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/8/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/9/device_maxeinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/1/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/2/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/3/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/4/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/5/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/6/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/7/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/8/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/9/device_mineinschaltdauer", 0],
	["openWB/config/get/SmartHome/Devices/1/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/2/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/3/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/4/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/5/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/6/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/7/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/8/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/9/device_deactivateWhileEvCharging", 0],
	["openWB/config/get/SmartHome/Devices/1/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/2/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/3/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/4/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/5/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/6/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/7/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/8/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/9/device_speichersocbeforestop", 0],
	["openWB/config/get/SmartHome/Devices/1/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/2/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/3/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/4/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/5/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/6/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/7/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/8/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/9/device_speichersocbeforestart", 0],
	["openWB/config/get/SmartHome/Devices/1/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/2/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/3/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/4/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/5/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/6/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/7/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/8/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/9/device_temperatur_configured", 0],
	["openWB/config/get/SmartHome/Devices/1/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/2/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/3/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/4/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/5/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/6/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/7/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/8/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/9/device_ausschaltverzoegerung", 0],
	["openWB/config/get/SmartHome/Devices/1/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/2/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/3/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/4/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/5/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/6/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/7/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/8/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/9/device_einschalturl", 0],
	["openWB/config/get/SmartHome/Devices/1/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/2/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/3/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/4/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/5/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/6/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/7/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/8/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/9/device_ausschalturl", 0],
	["openWB/config/get/SmartHome/Devices/1/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/2/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/3/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/4/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/5/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/6/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/7/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/8/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/9/device_leistungurl", 0],
	["openWB/config/get/SmartHome/Devices/1/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/2/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/3/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/4/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/5/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/6/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/7/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/8/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/9/device_measureurl", 0],
	["openWB/config/get/SmartHome/Devices/1/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/2/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/3/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/4/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/5/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/6/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/7/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/8/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/9/device_measureurlc", 0],
	["openWB/config/get/SmartHome/Devices/1/device_username", 0],
	["openWB/config/get/SmartHome/Devices/2/device_username", 0],
	["openWB/config/get/SmartHome/Devices/3/device_username", 0],
	["openWB/config/get/SmartHome/Devices/4/device_username", 0],
	["openWB/config/get/SmartHome/Devices/5/device_username", 0],
	["openWB/config/get/SmartHome/Devices/6/device_username", 0],
	["openWB/config/get/SmartHome/Devices/7/device_username", 0],
	["openWB/config/get/SmartHome/Devices/8/device_username", 0],
	["openWB/config/get/SmartHome/Devices/9/device_username", 0],
	["openWB/config/get/SmartHome/Devices/1/device_password", 0],
	["openWB/config/get/SmartHome/Devices/2/device_password", 0],
	["openWB/config/get/SmartHome/Devices/3/device_password", 0],
	["openWB/config/get/SmartHome/Devices/4/device_password", 0],
	["openWB/config/get/SmartHome/Devices/5/device_password", 0],
	["openWB/config/get/SmartHome/Devices/6/device_password", 0],
	["openWB/config/get/SmartHome/Devices/7/device_password", 0],
	["openWB/config/get/SmartHome/Devices/8/device_password", 0],
	["openWB/config/get/SmartHome/Devices/9/device_password", 0],
	["openWB/config/get/SmartHome/Devices/1/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/2/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/3/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/4/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/5/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/6/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/7/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/8/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/9/device_actor", 0],
	["openWB/config/get/SmartHome/Devices/1/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/2/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/3/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/4/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/5/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/6/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/7/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/8/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/9/device_acthortype", 0],
	["openWB/config/get/SmartHome/Devices/1/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/2/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/3/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/4/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/5/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/6/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/7/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/8/device_acthorpower", 0],
	["openWB/config/get/SmartHome/Devices/9/device_acthorpower", 0]
];
